﻿Imports System.IO
Imports System.Net
Imports System.Text
Imports System.Xml

Public Class Form1

    '終了ボタンの処理
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim EF = MsgBox("アプリケーションを終了します", MsgBoxStyle.OkCancel)
        'OKなら終了
        If EF = MsgBoxResult.Ok Then
            End
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '右側の結果ウインドウは入力不可にして
        Me.TextBox2.Enabled = False

        '操作に関するメッセージを出しておきます
        Me.TextBox2.Text = "原文を入力して「ふりがな」ボタンを押してください。" + vbCrLf
        Me.TextBox2.Text += vbCrLf + "通信障害や引数でのエラーが発生した場合，ここに情報が表示されます。"
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        'APIの呼び出しURL
        Dim YJ_URL As String
        YJ_URL = "http://jlp.yahooapis.jp/FuriganaService/V1/furigana?"

        'アプリケーションID
        'あなたが取得したアプリケーションIDを記入してください
        Dim APP_ID As String
        APP_ID = "XXXXXXXX" 'ここにあなたのアプリケーションID

        '呼び出しURLを生成します
        YJ_URL += "appid=" + APP_ID

        'テキストボックスから原文の取得
        '文字コードをエンコードする必要はありません
        YJ_URL += "&sentence=" + Me.TextBox1.Text

        'ふりがなレベルの設定
        '1: 小学1年生向け。漢字（注2）にふりがなを付けます。
        '2: 小学2年生向け。1年生で習う漢字にはふりがなを付けません。
        '3: 小学3年生向け。1～2年生で習う漢字にはふりがを付けません。
        '4: 小学4年生向け。1～3年生で習う漢字にはふりがなを付けません。
        '5: 小学5年生向け。1～4年生で習う漢字にはふりがなを付けません。
        '6: 小学6年生向け。1～5年生で習う漢字にはふりがなを付けません。
        '7: 中学生以上向け。小学校で習う漢字にはふりがなを付けません。
        '8: 一般向け。常用漢字にはふりがなを付けません。
        '無指定の場合、ひらがなを含むテキストにふりがなを付けます。

        '学年指定する場合には次の行のコメントを外して任意の数字を指定します
        'YJ_URL += "&grade=1"


        If Me.TextBox1.Text = String.Empty Then
            MsgBox("原文を入力してからボタンを押してください")
            Exit Sub
        Else
            Me.TextBox2.Text = "サーバーと通信中です...." + vbCrLf + "しばらくお待ちください"
        End If

        'TextBox2の表示を更新しておきます
        Me.TextBox2.Refresh()


        Try

            '指定されたURLへのHTTP通信を生成して呼び出します
            Dim WReq As HttpWebRequest = HttpWebRequest.Create(YJ_URL)
            'サーバからのレスポンスを受け取ります
            Dim WRes As HttpWebResponse = WReq.GetResponse()

            'レスポンス・ボディの取得と表示
            'レスポンスのストリームを取得します
            Dim GRS As Stream = WRes.GetResponseStream()
            'レスポンスを読み取る器を用意して
            Dim STR As StreamReader = New StreamReader(GRS)
            '最後までレスポンスを読み込みます
            Dim ResHTML As String = STR.ReadToEnd()
            'リソース解放
            GRS.Close()
            STR.Close()

            'リソース解放
            WRes.Close()


            '読み込んだレスポンスを一旦XMLファイルとして保存します
            '文字コードはUTF-8です
            Dim FIO As New StreamWriter("tmp.xml", False, Encoding.UTF8)
            'レスポンスの内容を書き出します
            FIO.Write(ResHTML)
            FIO.Close()

            Dim XDC As XmlDocument = New XmlDocument()
            XDC.Load("tmp.xml")

            TextBox2.Enabled = True
            TextBox2.Text = String.Empty

            '書き出しフラグ
            Dim FLG_F As Boolean = False
            Dim FLG_R As Boolean = False
            Dim FLG_SUB As Boolean = True

            'ローマ字分の文字列バッファ
            Dim RMN As String = String.Empty

            'XMLの読み込み
            Dim XMR As New XmlTextReader("tmp.xml")
            While XMR.Read()
                Select Case XMR.NodeType
                    Case XmlNodeType.Element
                        '<SubWord>の場合
                        If XMR.Name = "SubWord" Then
                            FLG_SUB = False
                        End If

                        '<Furigana>の場合
                        If XMR.Name = "Furigana" And FLG_SUB = True Then
                            FLG_F = True
                        End If

                        '<Roman>の場合
                        If XMR.Name = "Roman" And FLG_SUB = True Then
                            FLG_R = True
                        End If


                    Case XmlNodeType.Text
                        'ふりがなはそのまま書き出し
                        If FLG_F = True Then
                            TextBox2.Text += XMR.Value
                            FLG_F = False
                        End If

                        'ローマ字は一旦バッファしておきます
                        If FLG_R = True Then
                            RMN += XMR.Value + " "
                            FLG_R = False
                        End If

                    Case XmlNodeType.EndElement
                        If XMR.Name = "SubWord" Then
                            FLG_SUB = True
                        End If

                End Select
            End While
            'XMLを閉じます
            XMR.Close()

            'バッファリングしておいたローマ字を書き出します
            TextBox2.Text += vbCrLf + vbCrLf
            TextBox2.Text += RMN

            'SAPIを使ってローマ字を読み上げてみます
            'あくまでもオマケの機能で現時点での実用性は保証できません
            '(実際に聞くと上で言っている意味がわかります)
            Dim TTS As Object
            TTS = CreateObject("SAPI.SpVoice")
            'SAPIは日本語は読めません。ですからローマ字を渡します。
            TTS.Speak(RMN)
            System.Runtime.InteropServices.Marshal.ReleaseComObject(TTS)
            TTS = Nothing


        Catch WEX As WebException
            'HTTP上のエラー
            '404 Not Foundなどがここにひっかかります
            Me.TextBox2.Text = "以下の問題が発生しています！" + vbCrLf + WEX.Message

        Catch AEX As Exception
            'その他，システム側でのエラーはここでキャッチします
            MsgBox("アプリケーションで問題が発生しました" + vbCrLf + AEX.Message)
        End Try


    End Sub
End Class
